{
  lib,
  config,
  ...
}:
with lib; {
  imports = [
    ./ayu.nix
    ./base16.nix
    ./onedark.nix
    ./rose-pine.nix
    ./catppuccin.nix
    ./monokai-pro.nix
  ];

  options = {
    colorschemes.enable = mkEnableOption "Enable colorschemes module";
  };
  config = mkIf config.colorschemes.enable {
    ayu.enable = mkDefault false;
    base16.enable = mkDefault false;
    onedark.enable = mkDefault true;
    rose-pine.enable = mkDefault false;
    catppuccin.enable = mkDefault false;
    monokai-pro.enable = mkDefault false;
  };
}
